//
//  AMVersionChecker.h
//  ChemBuddy
//
//  Created by Andrew Merenbach on Sun Feb 16 2003.
//  Copyright (c) 2003 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>

extern NSString *AMAutomaticVersionCheckingKey;

@interface NSApplication (AMVersionChecker)

- (void)performUpdateCheck:(id)sender;
- (void)performSilentUpdateCheck:(id)sender;

@end

@interface AMVersionChecker : NSObject {
	NSBundle *AM_productBundle;
	NSURL *AM_versionDataURL;
	BOOL AM_interactive;
}

- (id)initWithBundle:(NSBundle *)bundle;
- (void)dealloc;

- (void)checkForUpdates:(NSBundle *)bundle;

@end

@interface AMVersionChecker (AccessorMethods)

- (NSBundle *)productBundle;
- (void)setProductBundle:(NSBundle *)aBundle;
- (NSURL *)versionDataURL;
- (void)setVersionDataURL:(NSURL *)aURL;
- (BOOL)isInteractive;
- (void)setInteractive:(BOOL)flag;

@end

@interface AMVersionChecker (CheckerMethods)

- (BOOL)openVersionDataURL:(NSString *)aURL;

- (void)displayNewVersionAlert:(NSDictionary *)productVersionDict;
- (void)displayNoNewVersionAlert;
- (void)displayInvalidDataWarning;
- (void)displayConnectivityWarning;

@end