//
//  XQPatternDetector.h
//  Quotient
//
//  Created by Andrew Merenbach on 5/11/06.
//  Copyright 2006 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AMShellWrapper.h"

@class XQEquationController;


@interface XQPatternDetector : NSObject <AMShellWrapperController> {
	NSString *AM_repetendString;
	NSMutableString *repetendStringCache;
	
	NSString *AM_quotientString;
	
	BOOL AM_detecting;	// are we in the midst of a detection?
		
	BOOL shouldContinueDetection;

	AMShellWrapper *AM_shellWrapper;
	
	IBOutlet NSTextView *textOutlet;
	IBOutlet NSTextView *errorOutlet;
	IBOutlet NSProgressIndicator *progressIndicator;
	
	IBOutlet NSButton *runButton;
	
	IBOutlet XQEquationController *equationController;
}

//+ (void)initialize;

- (id)init;
- (void)dealloc;

- (void)loadValuesFromDefaults:(id)sender;
- (void)saveValuesToDefaults:(id)sender;

- (void)startDetection:(id)sender;
- (void)stopDetection:(id)sender;

- (void)setNilValueForKey:(NSString *)key;

@end


@interface XQPatternDetector (EquationAccessors)

- (NSString *)repetendString;
- (void)setRepetendString:(NSString *)aString;

- (BOOL)isDetecting;
- (void)setDetecting:(BOOL)flag;

- (AMShellWrapper *)shellWrapper;
- (void)setShellWrapper:(AMShellWrapper *)shellWrapper;

//- (BOOL)shouldDetectRepetend;
//- (void)setShouldDetectRepetend:(BOOL)flag;

@end
